"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = void 0;
var _reactNative = require("react-native");
var _type = require("./type");
Object.keys(_type).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _type[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _type[key];
    }
  });
});
async function reqeustRecordAndStoragePermission() {
  try {
    const granted = await _reactNative.PermissionsAndroid.requestMultiple(['android.permission.RECORD_AUDIO', 'android.permission.WRITE_EXTERNAL_STORAGE']);
    if (Object.values(granted).every(value => value === 'granted')) return true;else return false;
  } catch (err) {
    return false;
  }
}
const LINKING_ERROR = `The package 'react-native-background-audio-record' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo Go\n';
const BackgroundAudioRecord = _reactNative.NativeModules.BackgroundAudioRecord ? _reactNative.NativeModules.BackgroundAudioRecord : new Proxy({}, {
  get() {
    throw new Error(LINKING_ERROR);
  }
});
const BgRecorder = function () {
  let instance;
  let isRecording = false;
  let isPlaying = false;
  function getPlayer() {
    return {
      startRecord: async function startRecord({
        path,
        notificationConfig,
        audioConfig
      } = {}) {
        try {
          if (_reactNative.Platform.OS === 'android') {
            if (await reqeustRecordAndStoragePermission()) {
              if (isRecording === false) {
                isRecording = true;
                BackgroundAudioRecord.startRecord(path, audioConfig, notificationConfig);
              } else {
                console.warn('already recording...');
              }
            }
          }
        } catch (e) {
          console.warn(e);
        }
      },
      stopRecord: function stopRecord() {
        if (_reactNative.Platform.OS === 'android') {
          isRecording = false;
          return BackgroundAudioRecord.stopRecord();
        }
      },
      startAudio: function startAudio(path) {
        if (_reactNative.Platform.OS === 'android') {
          if (isPlaying === false) {
            isPlaying = true;
            BackgroundAudioRecord.playAudio(path);
          } else {
            console.warn('already playing...');
          }
        }
      },
      stopAudio: function stopAudio() {
        if (_reactNative.Platform.OS === 'android') {
          isPlaying = false;
          BackgroundAudioRecord.stopAudio();
        }
      }
    };
  }
  return {
    recorder: function () {
      if (instance === undefined) {
        instance = getPlayer();
      }
      return instance;
    }
  };
}();
var _default = exports.default = BgRecorder;
//# sourceMappingURL=index.js.map